/*
 * Copyright 2010 Allied Telesis.
 */

#include <common.h>
#include <ioports.h>

/*
 * I/O Port configuration table
 *
 * if conf is 1, then that port pin will be configured at boot time
 * according to the five values podr/pdir/ppar/psor/pdat for that entry
 */

const iop_conf_t iop_conf_tab[4][32] = {

    /* Port A configuration */
    {   /*            conf ppar psor pdir podr pdat */
	/* PA31 */ {   1,   1,   1,   0,   0,   0   },
	/* PA30 */ {   1,   1,   1,   0,   0,   0   },
	/* PA29 */ {   1,   1,   1,   1,   0,   0   },
	/* PA28 */ {   1,   1,   1,   1,   0,   0   },
	/* PA27 */ {   1,   1,   1,   0,   0,   0   },
	/* PA26 */ {   1,   0,   0,   1,   0,   0   },
	/* PA25 */ {   1,   0,   0,   1,   0,   0   },
	/* PA24 */ {   1,   0,   0,   1,   0,   0   },
	/* PA23 */ {   1,   0,   0,   1,   0,   0   },
	/* PA22 */ {   1,   0,   0,   1,   0,   0   },
	/* PA21 */ {   1,   1,   0,   1,   0,   0   },
	/* PA20 */ {   1,   1,   0,   1,   0,   0   },
	/* PA19 */ {   1,   1,   0,   1,   0,   0   },
	/* PA18 */ {   1,   1,   0,   1,   0,   0   },
	/* PA17 */ {   1,   1,   0,   0,   0,   0   },
	/* PA16 */ {   1,   1,   0,   0,   0,   0   },
	/* PA15 */ {   1,   1,   0,   0,   0,   0   },
	/* PA14 */ {   1,   1,   0,   0,   0,   0   },
	/* PA13 */ {   1,   0,   0,   1,   0,   0   },
	/* PA12 */ {   1,   0,   0,   1,   0,   0   },
	/* PA11 */ {   1,   0,   0,   1,   0,   0   },
	/* PA10 */ {   1,   0,   0,   1,   0,   0   },
	/* PA9  */ {   1,   0,   0,   1,   0,   0   },
	/* PA8  */ {   1,   0,   0,   1,   0,   0   },
	/* PA7  */ {   1,   0,   0,   0,   0,   0   },
	/* PA6  */ {   1,   0,   0,   0,   0,   0   },
	/* PA5  */ {   1,   0,   0,   0,   0,   0   },
	/* PA4  */ {   1,   0,   0,   0,   0,   0   },
	/* PA3  */ {   1,   0,   0,   0,   0,   0   },
	/* PA2  */ {   1,   0,   0,   0,   0,   0   },
	/* PA1  */ {   1,   0,   0,   0,   0,   0   },
	/* PA0  */ {   1,   0,   0,   0,   0,   0   }
    },

    /* Port B configuration */
    {   /*            conf ppar psor pdir podr pdat */
	/* PB31 */ {   1,   0,   0,   1,   0,   0   },
	/* PB30 */ {   1,   0,   0,   1,   0,   0   },
	/* PB29 */ {   1,   0,   0,   0,   0,   0   },
	/* PB28 */ {   1,   1,   1,   1,   0,   0   },
	/* PB27 */ {   1,   1,   1,   0,   0,   0   },
	/* PB26 */ {   1,   1,   1,   0,   0,   0   },
	/* PB25 */ {   1,   0,   0,   0,   0,   0   },
	/* PB24 */ {   1,   1,   1,   0,   0,   0   },
	/* PB23 */ {   1,   0,   0,   0,   0,   0   },
	/* PB22 */ {   1,   0,   0,   0,   0,   0   },
	/* PB21 */ {   1,   0,   0,   1,   0,   0   },
	/* PB20 */ {   1,   0,   0,   0,   0,   0   },
	/* PB19 */ {   1,   0,   0,   0,   0,   0   },
	/* PB18 */ {   1,   0,   0,   1,   0,   0   },
	/* PB17 */ {   1,   0,   0,   0,   0,   0   },
	/* PB16 */ {   1,   0,   0,   0,   0,   0   },
	/* PB15 */ {   1,   0,   0,   0,   0,   0   },
	/* PB14 */ {   1,   0,   0,   0,   0,   0   },
	/* PB13 */ {   1,   0,   0,   0,   0,   0   },
	/* PB12 */ {   1,   0,   0,   0,   0,   0   },
	/* PB11 */ {   1,   0,   0,   0,   0,   0   },
	/* PB10 */ {   1,   0,   0,   0,   0,   0   },
	/* PB9  */ {   1,   0,   0,   0,   0,   0   },
	/* PB8  */ {   1,   0,   0,   0,   0,   0   },
	/* PB7  */ {   1,   0,   0,   0,   0,   0   },
	/* PB6  */ {   1,   0,   0,   0,   0,   0   },
	/* PB5  */ {   1,   0,   0,   0,   0,   0   },
	/* PB4  */ {   1,   0,   0,   0,   0,   0   },
	/* PB3  */ {   0,   0,   0,   0,   0,   0   },
	/* PB2  */ {   0,   0,   0,   0,   0,   0   },
	/* PB1  */ {   0,   0,   0,   0,   0,   0   },
	/* PB0  */ {   0,   0,   0,   0,   0,   0   }
    },

    /* Port C */
    {   /*            conf ppar psor pdir podr pdat */
	/* PC31 */ {   1,   0,   0,   0,   0,   0   },
	/* PC30 */ {   1,   0,   0,   0,   0,   0   },
	/* PC29 */ {   1,   1,   0,   0,   0,   0   },
	/* PC28 */ {   1,   1,   0,   0,   0,   0   },
	/* PC27 */ {   1,   1,   0,   0,   0,   0   },
	/* PC26 */ {   1,   1,   0,   0,   0,   0   },
	/* PC25 */ {   1,   0,   0,   1,   0,   0   },
	/* PC24 */ {   1,   0,   0,   0,   0,   0   },
	/* PC23 */ {   1,   1,   0,   0,   0,   0   },
	/* PC22 */ {   1,   0,   0,   0,   0,   0   },
	/* PC21 */ {   1,   1,   0,   0,   0,   0   },
	/* PC20 */ {   1,   1,   0,   0,   0,   0   },
	/* PC19 */ {   1,   1,   0,   0,   0,   0   },
	/* PC18 */ {   1,   0,   0,   1,   0,   0   },
	/* PC17 */ {   1,   0,   0,   1,   0,   0   },
	/* PC16 */ {   1,   0,   0,   1,   0,   0   },
	/* PC15 */ {   1,   1,   0,   0,   0,   1   },
	/* PC14 */ {   1,   1,   0,   0,   0,   1   },
	/* PC13 */ {   1,   0,   0,   0,   0,   1   },
	/* PC12 */ {   1,   0,   0,   1,   0,   1   },
	/* PC11 */ {   1,   1,   0,   0,   0,   1   },
	/* PC10 */ {   1,   1,   0,   0,   0,   1   },
	/* PC9  */ {   1,   0,   0,   1,   0,   0   },
	/* PC8  */ {   1,   0,   0,   1,   0,   0   },
	/* PC7  */ {   1,   0,   0,   1,   0,   0   },
	/* PC6  */ {   1,   0,   0,   1,   0,   0   },
	/* PC5  */ {   1,   0,   0,   1,   0,   0   },
	/* PC4  */ {   1,   0,   0,   1,   0,   0   },
	/* PC3  */ {   1,   0,   0,   0,   0,   0   },
	/* PC2  */ {   1,   0,   0,   0,   0,   0   },
	/* PC1  */ {   1,   0,   0,   1,   0,   0   },
	/* PC0  */ {   1,   0,   0,   1,   0,   0   }
    },

    /* Port D */
    {   /*            conf ppar psor pdir podr pdat */
	/* PD31 */ {   1,   1,   0,   0,   0,   0   },
	/* PD30 */ {   1,   0,   0,   0,   0,   0   },
	/* PD29 */ {   1,   1,   0,   1,   0,   1   },
	/* PD28 */ {   1,   0,   0,   0,   0,   0   },
	/* PD27 */ {   1,   0,   0,   0,   0,   0   },
	/* PD26 */ {   1,   0,   0,   0,   0,   0   },
	/* PD25 */ {   1,   1,   0,   0,   0,   0   },
	/* PD24 */ {   1,   1,   0,   1,   0,   0   },
	/* PD23 */ {   1,   1,   0,   1,   0,   1   },
	/* PD22 */ {   1,   1,   1,   0,   0,   0   },
	/* PD21 */ {   1,   1,   1,   0,   0,   0   },
	/* PD20 */ {   1,   1,   1,   0,   0,   0   },
	/* PD19 */ {   1,   0,   0,   0,   0,   0   },
	/* PD18 */ {   1,   0,   0,   1,   0,   0   },
	/* PD17 */ {   1,   0,   0,   1,   0,   0   },
	/* PD16 */ {   1,   0,   0,   0,   0,   0   },
	/* PD15 */ {   1,   0,   0,   0,   1,   0   },
	/* PD14 */ {   1,   0,   0,   1,   0,   0   },
	/* PD13 */ {   1,   0,   0,   1,   0,   0   },
	/* PD12 */ {   1,   0,   0,   0,   0,   0   },
	/* PD11 */ {   1,   0,   0,   0,   0,   0   },
	/* PD10 */ {   1,   0,   0,   0,   0,   0   },
	/* PD9  */ {   1,   0,   0,   0,   0,   0   },
	/* PD8  */ {   1,   0,   0,   0,   0,   0   },
	/* PD7  */ {   1,   0,   0,   0,   0,   0   },
	/* PD6  */ {   1,   0,   0,   0,   0,   0   },
	/* PD5  */ {   1,   0,   0,   0,   0,   0   },
	/* PD4  */ {   1,   0,   0,   0,   0,   0   },
	/* PD3  */ {   0,   0,   0,   0,   0,   0   },
	/* PD2  */ {   0,   0,   0,   0,   0,   0   },
	/* PD1  */ {   0,   0,   0,   0,   0,   0   },
	/* PD0  */ {   0,   0,   0,   0,   0,   0   }
    }
};
