/*
 * flash.c
 *
 * (C) Copyright 2013 Allied Telesis Labs NZ
 *
 * This file is released under the terms of GPL v2 and any later version.
 * See the file COPYING in the root directory of the source tree for details.
 */
#include <common.h>
#include <flash.h>

#ifndef CONFIG_SYS_FLASH_BANKS_LIST
/*
 * Override weak default with board specific version.
 * Used by x900 and SBx908 to deal with variable flash size.
 */
phys_addr_t cfi_flash_bank_addr(int bank)
{
	if (bank == 0)
		return CONFIG_SYS_FLASH_BASE;
	else {
		int i;
		unsigned long size = 0;

		for (i = 0; i < bank; i++)
			size += flash_info[i].size;

		return CONFIG_SYS_FLASH_BASE + size;
	}
}
#endif
