/*
 * progress.c
 *
 * Copyright (c) 2013 Allied Telesis Labs
 *
 * This file is licensed under the terms of the GNU General Public License
 * version 2. This program is licensed "as is" without any warranty of any
 * kind, whether express or implied.
 */
#include <common.h>
#include <bootstage.h>

#include <bootmenu.h>

/**
 * See README for detailed error codes and meanings
 */
void show_boot_progress (int val)
{
	switch (val) {
	case BOOTSTAGE_ID_CHECK_MAGIC:
		bootmenu_printf("Verifying release... ");
		break;
	case BOOTSTAGE_ID_FIT_KERNEL_START:
		bootmenu_printf("OK\n");
		break;
	case BOOTSTAGE_ID_RUN_OS:
		bootmenu_printf("Booting...\n");
		break;
	case -(BOOTSTAGE_ID_FIT_KERNEL_START+BOOTSTAGE_SUB_NO_UNIT_NAME):
		bootmenu_printf("Error: This release file is not intended for this device.\n");
		break;
	case -(BOOTSTAGE_ID_NET_NETLOOP_OK):
		/* Happens when the network loop is terminated (e.g. CTRL-C) */
	case -(BOOTSTAGE_ID_NET_CHECKSUM):
		/* Bad environment checksum */
		break;
	default:
		if (val < 0)
			printf("Error: %d\n", val);
		break;
	}
}
