/*
 * transitional header until we merge global_data.h
 *
 * (C) Copyright 2000-2010
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * Licensed under the GPL-2 or later.
 */

#ifndef __ASM_GENERIC_GLOBAL_DATA_FLAGS_H
#define __ASM_GENERIC_GLOBAL_DATA_FLAGS_H

/*
 * Global Data Flags
 *
 * Note: The low 16 bits are expected for common code.  If your arch
 *       really needs to add your own, use the high 16bits.
 */
#define GD_FLG_RELOC		0x0001	/* Code was relocated to RAM */
#define GD_FLG_DEVINIT		0x0002	/* Devices have been initialized */
#define GD_FLG_SILENT		0x0004	/* Silent mode */
#define GD_FLG_POSTFAIL		0x0008	/* Critical POST test failed */
#define GD_FLG_POSTSTOP		0x0010	/* POST seqeunce aborted */
#define GD_FLG_LOGINIT		0x0020	/* Log Buffer has been initialized */
#define GD_FLG_DISABLE_CONSOLE	0x0040	/* Disable console (in & out) */
#define GD_FLG_ENV_READY	0x0080	/* Environment imported into hash table */

#ifdef __ATL_CHANGE__
#define GD_FLG_UBSHELL		0x0100	/* Straight into U-Boot shell 		*/
#define GD_FLG_BOOTMENU		0x0200	/* Straight into bootmenu		*/          
#define GD_FLG_DIAGS		0x0400	/* Diagnostics menu 2		*/    
#define GD_FLG_DIAGS_STAGE2	0x0800	/* Diagnostics menu 2		*/    
#define GD_FLG_QUIT		0x1000	/* quit operation !!!!!!!		*/   
#define GD_FLG_ONEOFFBOOT_FORCED	0x2000
#define GD_FLG_PASSWORD_RECOVERY	0x4000
#define GD_FLG_DEFAULT_CONFIG	0x8000
#define GD_FLG_LOCKED_STATE	0x10000	/* locked status see CONFIG_USE_PASSWORD */
#endif /* __ATL_CHANGE__ */

#endif
