/*
 * atiat9424T.h
 * Matthew Millman
 */

/*
 * Configuration settings for the at9924t board.
 */

/* ------------------------------------------------------------------------- */

/*
 * board/config.h - configuration options, board specific
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#define CONFIG_THIS_DEVICE 4
#define CONFIG_ATIAT9424
#define CONFIG_COMPATIBLE_DEVICES 	\
{ 					\
	{ 292, "AT-9424Ts/XP" },	\
	{ 0, NULL }			\
}

//#define CONFIG_USE_CF_ETH

#ifdef CONFIG_USE_CF_ETH
#define CONFIG_DRIVER_SMC91111
#define CONFIG_SMC91111_BASE 0x70000000
#else
#define CONFIG_NET_MULTI
#define CONFIG_ETH_SWITCH		/* Boot from switch ports */
#endif

/*
 * High Level Configuration Options
 * (easy to change)
 */
#define CONFIG_DIAGNOSTICS
#define CONFIG_DIAG_EPI3
#define CONFIG_BOOTMENU
#define CFG_IDE_MAXBUS          1       
#define CFG_IDE_MAXDEVICE       1
//#define CFG_IDE_8BIT
#define CFG_ATA_STRIDE		2
#define CONFIG_ATI_16BIT_CFLASH_WITH_BACKWARDS_DATABUS
#define CFG_ATA_BASE_ADDR       0x70001000
#define CFG_ATA_IDE0_OFFSET     0x0000
#define CFG_ATA_DATA_OFFSET     0x0000
#define CFG_ATA_REG_OFFSET      0x0000
//#define CONFIG_ATAPI
#define CONFIG_DOS_PARTITION
//#define CONFIG_IDE_LED
//#define CONFIG_EXT_IDE_LED
#define CONFIG_COMPACTFLASH /* Only used by our bootmenu */
#define CONFIG_IDE_PREINIT

#define CONFIG_HARD_I2C
#define CFG_I2C_SPEED 		0
#define CFG_I2C_SLAVE 		0
//#define SPD_EEPROM_ADDRESS 	0x51
//#define CONFIG_SPD_EEPROM
 
#define CONFIG_MPC824X		1
#define CONFIG_MPC8245		1

#define CONFIG_CONS_INDEX	1

#define CONFIG_ENV_OVERWRITE

/* This must be included AFTER the definition of CONFIG_COMMANDS (if any)
 */

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP			/* undef to save memory		*/
#define CFG_PROMPT	"AT9424> "		/* Monitor Command Prompt	*/
#define CFG_CBSIZE	256		/* Console I/O Buffer Size	*/

#ifdef CFG_HUSH_PARSER
#define CFG_PROMPT_HUSH_PS2	"> "
#endif

//#define CONFIG_HW_WATCHDOG
//#define CFG_WATCHDOG_FREQ       (CFG_HZ / 10)
#define CONFIG_BOARD_EARLY_INIT_F		/* call board_pre_init */
#define CONFIG_MISC_INIT_R

/* Print Buffer Size
 */
#define CFG_BARGSIZE	CFG_CBSIZE	/* Boot Argument Buffer Size	*/

/*-----------------------------------------------------------------------
 * Start addresses for the final memory configuration
 * (Set up by the startup code)
 * Please note that CFG_SDRAM_BASE _must_ start at 0
 */
#define CFG_SDRAM_BASE	    0x00000000

#define CFG_EUMB_ADDR       0x80100000

#define CFG_MONITOR_BASE    TEXT_BASE

#define CFG_MEMTEST_START   0x00004000	/* memtest works on		*/
#define CFG_MEMTEST_END	    0x02000000	/* 0 ... 32 MB in DRAM		*/

	/* Maximum amount of RAM.
	 */
//#define CFG_SDRAM_DSCD  0x20

#define CFG_MAX_RAM_SIZE    0x08000000

#if CFG_MONITOR_BASE >= CFG_FLASH_BASE
#undef CFG_RAMBOOT
#else
#define CFG_RAMBOOT
#endif

#define CONFIG_EPI3_LOCATION    0xFFFE0000
#define CONFIG_EPI3_SIZE        0x10000


#define CFG_GBL_DATA_SIZE    128

#define CFG_INIT_RAM_ADDR     0x08000000
#define CFG_INIT_RAM_END      0x1000
#define CFG_GBL_DATA_OFFSET  (CFG_INIT_RAM_END - CFG_GBL_DATA_SIZE)

/*
 * NS16550 Configuration
 */
#define CFG_NS16550
#define CFG_NS16550_SERIAL

#define CFG_NS16550_REG_SIZE	1

#define CFG_NS16550_CLK		get_bus_freq(0)

#define CFG_NS16550_COM1	(CFG_EUMB_ADDR + 0x4500)

/*
 * Low Level Configuration Settings
 * (address mappings, register initial values, etc.)
 * You should know what you are doing if you make changes here.
 * For the detail description refer to the MPC8240 user's manual.
 */

#ifdef CONFIG_AT9448
#define CONFIG_SYS_CLK_FREQ  33000000
#else
#define CONFIG_SYS_CLK_FREQ  66000000
#endif

#define CFG_HZ		     1000
#define CONFIG_PLL_PCI_TO_MEM_MULTIPLIER 3

#define CFG_ODCR	    0x15

/* RAM */

#define CFG_IBAT0U	(0x00000000 | BATU_BL_256M | BATU_VS | BATU_VP)
#define CFG_IBAT0L 	(0x00000000 | BATL_MEMCOHERENCE | BATL_PP_10)

/* ROM */

#define CFG_IBAT1U	(0xFFF00000 | BATU_BL_1M | BATU_VS | BATU_VP)
#define CFG_IBAT1L	(0xFFF00000 | BATL_MEMCOHERENCE | BATL_PP_10)

/* Init ram */

#define CFG_IBAT2L	(CFG_INIT_RAM_ADDR | BATL_PP_10 | BATL_MEMCOHERENCE)
#define CFG_IBAT2U	(CFG_INIT_RAM_ADDR | BATU_BL_128K | BATU_VS | BATU_VP)

/* Unused I-Bat */

#define CFG_IBAT3U	(0x41000000 | BATU_BL_128K | BATU_VS | BATU_VP)
#define CFG_IBAT3L	(0x41000000 | BATL_MEMCOHERENCE | BATL_PP_10)

/* RAM (0-255M) */

#define CFG_DBAT0U	(0x00000000 | BATU_BL_256M | BATU_VS | BATU_VP)
#define CFG_DBAT0L	(0x00000000 | BATL_MEMCOHERENCE | BATL_PP_10)

/* Extended ROM */

#define CFG_DBAT1U	(0x70000000 | BATU_BL_256M | BATU_VS | BATU_VP)
#define CFG_DBAT1L	(0x70000000 | BATL_WRITETHROUGH | BATL_CACHEINHIBIT | BATL_MEMCOHERENCE | BATL_GUARDEDSTORAGE | BATL_PP_10)

/* PCI */

#define CFG_DBAT2U	(0x80000000 | BATU_BL_256M | BATU_VS | BATU_VP)
#define CFG_DBAT2L	(0x80000000 | BATL_WRITETHROUGH | BATL_CACHEINHIBIT | BATL_MEMCOHERENCE | BATL_GUARDEDSTORAGE | BATL_PP_10)

/* IO */

#define CFG_DBAT3U	(0xF0000000 | BATU_BL_256M | BATU_VS | BATU_VP)
#define CFG_DBAT3L	(0xF0000000 | BATL_WRITETHROUGH | BATL_CACHEINHIBIT | BATL_MEMCOHERENCE | BATL_GUARDEDSTORAGE | BATL_PP_10)

#define CFG_BANK0_ENABLE    1
#define CFG_BANK1_ENABLE    0
#define CFG_BANK2_ENABLE    0
#define CFG_BANK3_ENABLE    0
#define CFG_BANK4_ENABLE    0
#define CFG_BANK5_ENABLE    0
#define CFG_BANK6_ENABLE    0
#define CFG_BANK7_ENABLE    0

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 8 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */

#define CFG_BOOTMAPSZ	    (8 << 20)	/* Initial Memory map for Linux */

/*-----------------------------------------------------------------------
 * FLASH organization
 */
#define CFG_MAX_FLASH_BANKS	2	/* Max number of flash banks		*/
#define CFG_MAX_FLASH_SECT	256	/* Max number of sectors in one bank	*/

#define CFG_FLASH_ERASE_TOUT	120000	/* Timeout for Flash Erase (in ms)	*/
#define CFG_FLASH_WRITE_TOUT	500	/* Timeout for Flash Write (in ms)	*/

#define CFG_FLASH_BASE		0x7C000000
#define CFG_BOOTROM_BASE	0xFFF00000
//#define CFG_FLASH_PROTECTION

#define CONFIG_UBOOT_ROM_BASE 0xFFF00000


/*
 * Init Memory Controller:
 *
 * BR0/1 and OR0/1 (FLASH)
 */

#define FLASH_BASE0_PRELIM      CFG_FLASH_BASE  /* FLASH bank #0        */
#define FLASH_BASE1_PRELIM      0               /* FLASH bank #1        */

	/* Warining: environment is not EMBEDDED in the U-Boot code.
	 * It's stored in flash separately.
	 */

#define CFG_FLASH_CFI


#define CFG_ENV_EARLY_PAGE	0x6
#define CFG_ENV_ADDR		0xFFFF0000
#define CFG_ENV_SIZE		0x2000	/* Size of the Environment		*/
#define CFG_ENV_OFFSET		0	/* starting right at the beginning	*/
#define CFG_ENV_SECT_SIZE	0x10000 /* Size of the Environment Sector	*/

#define CONFIG_8BIT_ROM /* Used by bootmenu */

#define CFG_FLASH_INCREMENT 1
#define CFG_FLASH_USE_BUFFER_WRITE
//#define CFG_FLASH_PROTECTION

#define CONFIG_UBOOT_SIZE 0xC0000
#define CONFIG_UBOOT_FLASH_BASE 0xFFF00000

#define CONFIG_NVS_LOCATION 	0xFFE80000
#define CONFIG_NVS_SIZE		0x80000

#define CONFIG_JFFS2_PART_OFFSET 0x0
#define CONFIG_JFFS2_PART_SIZE  atl_get_jffs2_part_size()

#define CONFIG_DIAGMEM_BASE     0x1000000

#define CONFIG_SYS_LOAD_ADDR  0x1000000      /* default location for tftp and bootm */

#include <configs/atl-std-opts.h>

#define CONFIG_COMMANDS         ( CONFIG_GENERIC_COMMANDS | \
				  CFG_CMD_I2C | \
 				  CFG_CMD_IDE | CONFIG_CMD_AWP )


#include <cmd_confdefs.h>


/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_CACHELINE_SIZE	32
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#  define CFG_CACHELINE_SHIFT	5	/* log base 2 of the above value	*/
#endif

/*
 * Internal Definitions
 *
 * Boot Flags
 */
#define BOOTFLAG_COLD		0x01	/* Normal Power-On: Boot from FLASH	*/
#define BOOTFLAG_WARM		0x02	/* Software reboot			*/

/*-----------------------------------------------------------------------
 * PCI stuff
 *-----------------------------------------------------------------------
 */
#define CONFIG_PCI			/* include pci support			*/
//#define CONFIG_PCI_PNP                  /* we need Plug 'n Play */
//#define CONFIG_NET_MULTI		/* Multi ethernet cards support */
#define CFG_RX_ETH_BUFFER	8       /* use 8 rx buffer on eepro100  */
#endif /* __CONFIG_H */
